'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _getComponentModuleJSCode = require('./getComponentModuleJSCode');

var _getComponentModuleJSCode2 = _interopRequireDefault(_getComponentModuleJSCode);

var _getDocFile = require('./getDocFile');

var _getDocFile2 = _interopRequireDefault(_getDocFile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var stateDoc = function () {
	function stateDoc() {
		(0, _classCallCheck3.default)(this, stateDoc);

		this.file = '';
		this.docComponent = false;
		this.docMixins = [];
	}

	(0, _createClass3.default)(stateDoc, [{
		key: 'isMainComponent',
		value: function isMainComponent(file) {
			return file === this.file;
		}
	}, {
		key: 'saveComponent',
		value: function saveComponent(source, file) {
			if (!this.docComponent) {
				var jscodeReqest = (0, _getComponentModuleJSCode2.default)(source, file);
				var doc = (0, _getDocFile2.default)(jscodeReqest, file);
				this.docComponent = doc;
			}
		}
	}, {
		key: 'isMixin',
		value: function isMixin(doc) {
			return doc.some(function (docPart) {
				return docPart.kind === 'mixin';
			});
		}
	}, {
		key: 'saveMixin',
		value: function saveMixin(source, file) {
			var doc = (0, _getDocFile2.default)(source, file);
			if (this.isMixin(doc)) {

				doc = doc.map(function (docPart) {
					var longnameSplit = docPart.longname.split('.');
					if (longnameSplit[0] === 'default') {
						longnameSplit[0] = 'module.exports';
					}
					docPart.longname = longnameSplit.join('.');
					return docPart;
				}).filter(function (docPart) {
					return docPart.longname !== 'module.exports';
				}).filter(function (docPart) {
					return docPart.kind !== 'package';
				});
				this.docComponent = this.docComponent.concat(doc);
			}
		}
	}]);
	return stateDoc;
}();

exports.default = new stateDoc();